/* DisplayWidget.c generated by valac 0.38.10, the Vala compiler
 * generated from DisplayWidget.vala, do not modify */

/*
* Copyright (c) 2016-2018 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_DISPLAY_WIDGET (display_widget_get_type ())
#define DISPLAY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DISPLAY_WIDGET, DisplayWidget))
#define DISPLAY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DISPLAY_WIDGET, DisplayWidgetClass))
#define IS_DISPLAY_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DISPLAY_WIDGET))
#define IS_DISPLAY_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DISPLAY_WIDGET))
#define DISPLAY_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DISPLAY_WIDGET, DisplayWidgetClass))

typedef struct _DisplayWidget DisplayWidget;
typedef struct _DisplayWidgetClass DisplayWidgetClass;
typedef struct _DisplayWidgetPrivate DisplayWidgetPrivate;
enum  {
	DISPLAY_WIDGET_0_PROPERTY,
	DISPLAY_WIDGET_SHOW_MIC_PROPERTY,
	DISPLAY_WIDGET_ICON_NAME_PROPERTY,
	DISPLAY_WIDGET_NUM_PROPERTIES
};
static GParamSpec* display_widget_properties[DISPLAY_WIDGET_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DisplayWidget {
	GtkGrid parent_instance;
	DisplayWidgetPrivate * priv;
};

struct _DisplayWidgetClass {
	GtkGridClass parent_class;
};

struct _DisplayWidgetPrivate {
	gboolean _show_mic;
	gchar* _icon_name;
};


static gpointer display_widget_parent_class = NULL;

GType display_widget_get_type (void) G_GNUC_CONST;
#define DISPLAY_WIDGET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DISPLAY_WIDGET, DisplayWidgetPrivate))
DisplayWidget* display_widget_new (void);
DisplayWidget* display_widget_construct (GType object_type);
gboolean display_widget_get_show_mic (DisplayWidget* self);
void display_widget_set_show_mic (DisplayWidget* self, gboolean value);
const gchar* display_widget_get_icon_name (DisplayWidget* self);
void display_widget_set_icon_name (DisplayWidget* self, const gchar* value);
static GObject * display_widget_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void display_widget_finalize (GObject * obj);
static void _vala_display_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_display_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DisplayWidget* display_widget_construct (GType object_type) {
	DisplayWidget * self = NULL;
	self = (DisplayWidget*) g_object_new (object_type, NULL);
	return self;
}


DisplayWidget* display_widget_new (void) {
	return display_widget_construct (TYPE_DISPLAY_WIDGET);
}


gboolean display_widget_get_show_mic (DisplayWidget* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_mic;
	result = _tmp0_;
	return result;
}


void display_widget_set_show_mic (DisplayWidget* self, gboolean value) {
	g_return_if_fail (self != NULL);
	if (display_widget_get_show_mic (self) != value) {
		gboolean _tmp0_;
		_tmp0_ = value;
		self->priv->_show_mic = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_widget_properties[DISPLAY_WIDGET_SHOW_MIC_PROPERTY]);
	}
}


const gchar* display_widget_get_icon_name (DisplayWidget* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon_name;
	result = _tmp0_;
	return result;
}


void display_widget_set_icon_name (DisplayWidget* self, const gchar* value) {
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, display_widget_get_icon_name (self)) != 0) {
		const gchar* _tmp0_;
		gchar* _tmp1_;
		_tmp0_ = value;
		_tmp1_ = g_strdup (_tmp0_);
		_g_free0 (self->priv->_icon_name);
		self->priv->_icon_name = _tmp1_;
		g_object_notify_by_pspec ((GObject *) self, display_widget_properties[DISPLAY_WIDGET_ICON_NAME_PROPERTY]);
	}
}


static GObject * display_widget_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	DisplayWidget * self;
	GtkImage* volume_icon = NULL;
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* mic_icon = NULL;
	GtkImage* _tmp2_;
	GtkImage* _tmp3_;
	GtkRevealer* mic_revealer = NULL;
	GtkRevealer* _tmp4_;
	GtkRevealer* _tmp5_;
	GtkRevealer* _tmp6_;
	GtkImage* _tmp7_;
	GtkRevealer* _tmp8_;
	GtkImage* _tmp9_;
	GtkImage* _tmp10_;
	GtkRevealer* _tmp11_;
	parent_class = G_OBJECT_CLASS (display_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISPLAY_WIDGET, DisplayWidget);
	_tmp0_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp0_);
	volume_icon = _tmp0_;
	_tmp1_ = volume_icon;
	gtk_image_set_pixel_size (_tmp1_, 24);
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-input-microphone-symbolic", GTK_ICON_SIZE_LARGE_TOOLBAR);
	g_object_ref_sink (_tmp2_);
	mic_icon = _tmp2_;
	_tmp3_ = mic_icon;
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 18);
	_tmp4_ = (GtkRevealer*) gtk_revealer_new ();
	g_object_ref_sink (_tmp4_);
	mic_revealer = _tmp4_;
	_tmp5_ = mic_revealer;
	gtk_revealer_set_transition_type (_tmp5_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
	_tmp6_ = mic_revealer;
	_tmp7_ = mic_icon;
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp7_);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	_tmp8_ = mic_revealer;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp8_);
	_tmp9_ = volume_icon;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp9_);
	_tmp10_ = volume_icon;
	g_object_bind_property_with_closures ((GObject*) self, "icon-name", (GObject*) _tmp10_, "icon-name", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp11_ = mic_revealer;
	g_object_bind_property_with_closures ((GObject*) self, "show-mic", (GObject*) _tmp11_, "reveal-child", G_BINDING_BIDIRECTIONAL | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_g_object_unref0 (mic_revealer);
	_g_object_unref0 (mic_icon);
	_g_object_unref0 (volume_icon);
	return obj;
}


static void display_widget_class_init (DisplayWidgetClass * klass) {
	display_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DisplayWidgetPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_display_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_WIDGET_SHOW_MIC_PROPERTY, display_widget_properties[DISPLAY_WIDGET_SHOW_MIC_PROPERTY] = g_param_spec_boolean ("show-mic", "show-mic", "show-mic", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_WIDGET_ICON_NAME_PROPERTY, display_widget_properties[DISPLAY_WIDGET_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void display_widget_instance_init (DisplayWidget * self) {
	self->priv = DISPLAY_WIDGET_GET_PRIVATE (self);
}


static void display_widget_finalize (GObject * obj) {
	DisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DISPLAY_WIDGET, DisplayWidget);
	_g_free0 (self->priv->_icon_name);
	G_OBJECT_CLASS (display_widget_parent_class)->finalize (obj);
}


GType display_widget_get_type (void) {
	static volatile gsize display_widget_type_id__volatile = 0;
	if (g_once_init_enter (&display_widget_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DisplayWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayWidget), 0, (GInstanceInitFunc) display_widget_instance_init, NULL };
		GType display_widget_type_id;
		display_widget_type_id = g_type_register_static (gtk_grid_get_type (), "DisplayWidget", &g_define_type_info, 0);
		g_once_init_leave (&display_widget_type_id__volatile, display_widget_type_id);
	}
	return display_widget_type_id__volatile;
}


static void _vala_display_widget_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DISPLAY_WIDGET, DisplayWidget);
	switch (property_id) {
		case DISPLAY_WIDGET_SHOW_MIC_PROPERTY:
		g_value_set_boolean (value, display_widget_get_show_mic (self));
		break;
		case DISPLAY_WIDGET_ICON_NAME_PROPERTY:
		g_value_set_string (value, display_widget_get_icon_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_display_widget_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DISPLAY_WIDGET, DisplayWidget);
	switch (property_id) {
		case DISPLAY_WIDGET_SHOW_MIC_PROPERTY:
		display_widget_set_show_mic (self, g_value_get_boolean (value));
		break;
		case DISPLAY_WIDGET_ICON_NAME_PROPERTY:
		display_widget_set_icon_name (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



